require(ica)

x <- read.table("TS_Simulat_EEG_Wiener.txt", header=TRUE)
nChannels <- dim(x)[2] -1
nTime <- dim(x)[1]

## Step 1:  Reject artifacts using infomax ICA
ica1 <- icaimax(x[,2:(nChannels+1)], nChannels)

for ( ch in 1:nChannels) {
dev.new()
	plot(x$Time, ica1$S[,ch], type='l')
}

# suppose component 4 is an artifact:
ica1$S[,4] <- 0
x1 <- with(ica1, tcrossprod(S,M))


#par(mfrow=c(nChannels,1))
for ( ch in 1:nChannels) {
dev.new()
	plot(x$Time, x1[,ch], type='l', col='red')
        lines(x$Time, x[,ch+1])
}



## Step 2: Time-Frequency
nFrex <- 64
allArray <- array(NA, c(nChannels, nTime, nFrex))
for (ch in 1:nChannels) { 
   ## Short time Fourier used in Shou et al.
   ## DWT may lead to different outcomes in the pipeline
   allArray[ch,,] <- computeDWT(x1[,ch], x[,1], 250, 5, 30, nFrex, 5)
}

tvec <- x[,1]
frex <- seq(5, 30, length.out=nFrex)
filled.contour(tvec, frex, allArray[1,,], nlevels=40)
	
## Step 3:  Normalize
all2D <- matrix(allArray, nrow=nChannels, ncol=nFrex*nTime, byrow=F)
all2D <- all2D - mean(all2D)
all2D <- all2D / sd(all2D)

## Step 4:  PCA Reduction
pca.all <- prcomp(all2D, retx=TRUE)
plot(pca.all$rotation[,1], type='l')

## Step 5:  ICA
ica5 <- icaimax(pca.all$rotation[,], nChannels)
#ica3d.2 <- matrix(ica5$S[,2], nFrex, nTime, byrow=F)
#filled.contour(x[,1], frex, t(ica3d.1), nlevels=40)

for ( ch in 1:nChannels) {
dev.new()
   ica3d <- matrix(ica5$S[,ch], nFrex, nTime, byrow=T)
   filled.contour(x[,1], frex, t(ica3d), nlevels=40)
	#plot(ica5$S[,ch], type='l')
}

